angular.module("umbraco").controller("Concorde.DeployDialogController", function ($scope, deployService, $q, $timeout) {

    var vm = this;
    vm.environment = {};
    vm.user = {};

    function queueDialogItem(currentNode) {
        //Deployment model
        var deployModel = {
            rootId: currentNode.id,
            includeDescendants: false,
            "package": false
        };

        //if we are deploying media, set the media provider
        if (currentNode.section === "media") {
            deployModel.provider = "d8e6ad87-e73a-11df-9492-0800200c9a66";
        }

        return deployService.addToManifest(deployModel);
    }

    function clearQueue() {
        return deployService.clearQueue().then(function () {
        });
    }

    function loadUaasData() {
        return deployService.environment().then(function (response) {

            vm.environment = response.data;
            vm.user = {
                isDebug: vm.environment.debug === true,
                isLocalEnvironment: vm.environment.localEnvironment === true,
                userType: vm.environment.userType,
                settingsSection: false,
                developerSection: false
            };

            vm.user.developerSection = vm.environment.userAllowedSections.indexOf("developer") >= 0;
            vm.user.settingsSection = vm.environment.userAllowedSections.indexOf("settings") >= 0;
            vm.user.isDeveloper = (vm.user.developerSection || vm.user.settingsSection);
        });
    }

    if ($scope.dialogOptions.currentNode) {

        //handle the dialog, we clear the queue, load in uaas data, add the current
        // item to the queue, start the subscriber and show the deploy confirm screen

        clearQueue()
            .then(function () {
                loadUaasData()
                    .then(function () {
                        //queue up the item and start it
                        queueDialogItem($scope.dialogOptions.currentNode)
                            .then(function () {

                            });
                    });
            });
    }
});